package com.zt.plat.module.qms.business.config.dal.mapper;

import com.zt.plat.framework.common.pojo.PageResult;
import com.zt.plat.framework.mybatis.core.query.LambdaQueryWrapperX;
import com.zt.plat.module.qms.business.config.controller.vo.*;
import com.zt.plat.module.qms.business.config.controller.vo.MaterialAssayStandardPageReqVO;
import com.zt.plat.module.qms.business.config.dal.dataobject.MaterialAssayStandardDO;
import com.zt.plat.framework.mybatis.core.mapper.BaseMapperX;
import com.zt.plat.module.qms.business.config.dal.dataobject.MaterialAssayStandardExtendDO;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

/**
 * 物料检测标准 Mapper
 *
 * @author 后台管理
 */
@Mapper
public interface MaterialAssayStandardMapper extends BaseMapperX<MaterialAssayStandardDO> {

    String tempDataKey = "tempDataKey";

    default PageResult<MaterialAssayStandardDO> selectPage(MaterialAssayStandardPageReqVO reqVO) {
        return selectPage(reqVO, new LambdaQueryWrapperX<MaterialAssayStandardDO>()
                .eqIfPresent(MaterialAssayStandardDO::getBaseSampleId, reqVO.getBaseSampleId())
                .eqIfPresent(MaterialAssayStandardDO::getMaterialId, reqVO.getMaterialId())
                .eqIfPresent(MaterialAssayStandardDO::getDictionaryBusinessId, reqVO.getDictionaryBusinessId())
                .eqIfPresent(MaterialAssayStandardDO::getSystemDepartmentCode, reqVO.getSystemDepartmentCode())
                .betweenIfPresent(MaterialAssayStandardDO::getCreateTime, reqVO.getCreateTime())
                .eqIfPresent(MaterialAssayStandardDO::getRemark, reqVO.getRemark())
                .ne(MaterialAssayStandardDO::getRemark, tempDataKey)
                .orderByDesc(MaterialAssayStandardDO::getId));
    }

    Page<MaterialAssayStandardExtendDO> selectPageWithExtend(IPage<?> page, @Param("param") MaterialAssayStandardPageReqVO param);


}